VERSION 5.00
Begin VB.Form frmAbout 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3840
   ClientLeft      =   15
   ClientTop       =   15
   ClientWidth     =   5760
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   6.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00FFFFFF&
   Icon            =   "frmAbout.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   256
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   384
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label lblVersion 
      BackStyle       =   0  'Transparent
      Caption         =   "Version 0.0.0"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H007F7F7F&
      Height          =   195
      Left            =   360
      TabIndex        =   0
      Top             =   780
      Width           =   2595
   End
End
Attribute VB_Name = "frmAbout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmAbout.frm
'   Purpose: The all-encompassing about form.
'
Option Explicit
Option Compare Binary
Option Base 0


Private Type BGString
    Text As String
    X As Single
    Y As Single
    vel As Single
End Type


Private creditFolks(17) As String
Private bgStrings(10) As BGString
    
Private matrixLoop As Boolean
Private counterFrequency As Currency


' API
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (ByRef Frequency As Currency) As Long
Private Declare Function QueryPerformanceCounter Lib "kernel32" (ByRef Counter As Currency) As Long


' Form events
Private Sub Form_Activate()

    Set Me.Font = lblVersion.Font

    matrixLoop = True
    doMatrixLoop

End Sub

Private Sub Form_Click()

    matrixLoop = False
    Me.Hide

End Sub

Private Sub Form_Load()

    Dim BetaString As String
    
    
    ' Load the splash image
    Me.Picture = LoadPicture(APP_PATH & "resources\splash.gif")
    
    ' Set the caption
    If BETAMESSAGE = True Then BetaString = " beta"
    lblVersion.Caption = "Version " & App.Major & "." & App.Minor & " build " & App.Revision & BetaString

    initMatrix
    
    appLog.Add "  Loaded " & Me.name

End Sub


' Init text scroller
Private Sub initMatrix()

    Dim A As Long
    
    
    ' Random seed
    Randomize Timer
    
    ' Init Credit Folks
    creditFolks(0) = "CodeImp"
    creditFolks(1) = "Looney"
    creditFolks(2) = "All the people from the previous WhackEds"
    creditFolks(3) = "EarthQuake"
    creditFolks(4) = "Andy Shawaluk"
    creditFolks(5) = "Francesco Orsenigo"
    creditFolks(6) = "XDelusion"
    creditFolks(7) = "Greg Lewis"
    creditFolks(8) = "iori"
    creditFolks(9) = "Cheese"
    creditFolks(10) = "Frades"
    creditFolks(11) = "Kurisutaru"
    creditFolks(12) = "Daniel Carroll"
    creditFolks(13) = "Dani J666"
    creditFolks(14) = "Doom Dude"
    creditFolks(15) = "Skullers"
    creditFolks(16) = "esselfortium"
    creditFolks(17) = "un4seen"
    
    ' Create random strings
    For A = 0 To UBound(bgStrings())
        setupBGString A
    Next A
    
    ' Get performance counter frequency
    QueryPerformanceFrequency counterFrequency
    counterFrequency = counterFrequency / 1000
    
End Sub


' Main scroller loop
Private Sub doMatrixLoop()

    Dim A As Long
    
    Dim pfCount As Currency
    Dim endTime As Currency
    Dim frameDelay As Currency
    
    Dim startPerf As Currency, endPerf As Currency
    
    
    frameDelay = counterFrequency * 16.6666667
    
    ' Drawing loop
    Do
        
        frmAbout.Cls
        
        For A = 0 To UBound(bgStrings())
            
            ' Move string
            bgStrings(A).X = bgStrings(A).X + bgStrings(A).vel
            
            ' Check for boundary reach
            If bgStrings(A).X > (frmAbout.Width / 15) Then setupBGString A
               
            ' Draw the text
            TextOut frmAbout.hDC, bgStrings(A).X, bgStrings(A).Y, bgStrings(A).Text, Len(bgStrings(A).Text)
            
        Next A
        

        ' Delay
        QueryPerformanceCounter endPerf

        ' Wait until next tick needs to be executed
        Do
            DoEvents
            QueryPerformanceCounter pfCount
        Loop Until pfCount >= endTime
        endTime = pfCount + frameDelay
        
    Loop Until matrixLoop = False

End Sub


' Create a new string for the scroller
Private Sub setupBGString(ByVal A As Long)

    bgStrings(A).Text = creditFolks(Int(Rnd * (UBound(creditFolks()) + 1)))
    
    bgStrings(A).vel = Rnd * 2 + 1
    bgStrings(A).X = -(Int(Rnd * frmAbout.ScaleWidth)) - frmAbout.ScaleWidth
    bgStrings(A).Y = Int(Rnd * 160) + 96
    
End Sub
