VERSION 5.00
Begin VB.Form frmEditAmmo 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Ammo editor"
   ClientHeight    =   2775
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5175
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmEditAmmo.frx":0000
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   ScaleHeight     =   185
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   345
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdRename 
      Caption         =   "Re&name"
      Height          =   375
      Left            =   180
      TabIndex        =   3
      ToolTipText     =   "Rename the current ammo item"
      Top             =   2220
      Width           =   2355
   End
   Begin VB.TextBox txtPickupAmmo 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1043
         SubFormatType   =   1
      EndProperty
      Height          =   315
      Left            =   3960
      TabIndex        =   2
      Text            =   "10"
      Top             =   600
      Width           =   975
   End
   Begin VB.TextBox txtMaxAmmo 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1043
         SubFormatType   =   1
      EndProperty
      Height          =   315
      Left            =   3960
      TabIndex        =   1
      Text            =   "200"
      Top             =   180
      Width           =   975
   End
   Begin VB.ListBox lstAmmo 
      Height          =   1875
      IntegralHeight  =   0   'False
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   1695
   End
   Begin VB.CommandButton cmdRestore 
      Caption         =   "&Restore"
      Height          =   375
      Left            =   2640
      TabIndex        =   4
      ToolTipText     =   "Restore the current ammo item"
      Top             =   2220
      Width           =   2355
   End
   Begin VB.Label lblPickupAmmo 
      Caption         =   "Pickup ammo"
      Height          =   195
      Left            =   2100
      TabIndex        =   6
      Top             =   660
      Width           =   1695
   End
   Begin VB.Label lblMaxAmmo 
      Caption         =   "Maximum ammo"
      Height          =   195
      Left            =   2100
      TabIndex        =   5
      Top             =   240
      Width           =   1695
   End
End
Attribute VB_Name = "frmEditAmmo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmEditAmmo.frm
'   Purpose: The ammo editor
'
Option Explicit
Option Compare Binary
Option Base 0


' The currently selected item
Private Selected As Long


' Rename an entry
Private Sub cmdRename_Click()
    
    Dim Dummy As String


    ' Display the box
    Dummy = InputBox("Enter a new name", "Ammo " & Selected, Patch.AmmoNames(Selected))
    
    ' Update the places where the ammo name is used and stored
    If Dummy <> vbNullString Then
        Patch.AmmoNames(Selected) = Dummy
        lstAmmo.List(Selected) = Dummy
        patchHasChanged
    End If
    
End Sub


' Form vents
Private Sub Form_Load()

    appLog.Add "  Loaded " & Me.Name

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Hide the form instead
    Me.Hide
    frmMain.tlbEditors.Buttons(7).Value = tbrUnpressed
    Cancel = 1

End Sub


' Fill the form with the relevant data
Public Sub fillStaticData()

    Dim A As Long
    Dim oldChanged As Boolean
    
    
    oldChanged = Patch.Changed
    
    ' Fill the list
    lstAmmo.Clear
    For A = 0 To UBound(Patch.AmmoNames())
        lstAmmo.AddItem Patch.AmmoNames(A)
    Next A
    
    lstAmmo.listIndex = 0
    
    Patch.Changed = oldChanged
    updateSavingFunctions

End Sub


' Change the selected entry
Private Sub lstAmmo_Click()

    Selected = lstAmmo.listIndex
    Me.updateForm
    
    If Me.Visible Then txtMaxAmmo.SetFocus

End Sub


' Update the form's data
Public Sub updateForm()

    txtMaxAmmo.Text = Patch.Ammo(Selected).Maximum
    txtPickupAmmo.Text = Patch.Ammo(Selected).Pickup

End Sub


' Doubleclicking and ammo entry = renaming it
Private Sub lstAmmo_DblClick()

    cmdRename_Click

End Sub


' Change amount of maximum ammo
Private Sub txtMaxAmmo_Change()

    Dim TestValue As Long
    
    
    TestValue = Val(txtMaxAmmo.Text)
    
    ' Boundary check
    If TestValue < 0 Then txtMaxAmmo.Text = "0"
    If TestValue > 999999 Then txtMaxAmmo.Text = "999999"
    
    ' Change the table entry
    Patch.Ammo(Selected).Maximum = Val(txtMaxAmmo.Text)

End Sub


' Select on focus
Private Sub txtMaxAmmo_GotFocus()
    selectAll txtMaxAmmo
End Sub
Private Sub txtPickupAmmo_GotFocus()
    selectAll txtPickupAmmo
End Sub


' Change amount of 'pickupable' ammo
Private Sub txtPickupAmmo_Change()

    Dim TestValue As Long
    
    
    TestValue = Val(txtPickupAmmo.Text)
    
    ' Boundary check
    If TestValue < 0 Then txtPickupAmmo.Text = "0"
    If TestValue > 999999 Then txtPickupAmmo.Text = "999999"
    
    ' Change the table entry
    Patch.Ammo(Selected).Pickup = Val(txtPickupAmmo.Text)

End Sub


' Restore the entry to the Engine. struct
Private Sub cmdRestore_Click()

    Dim Dummy As Long


    Dummy = MsgBox("Are you sure you want to restore this ammo entry?", vbYesNo Or vbQuestion)
    If Dummy = vbNo Then Exit Sub

    ' Restore the data
    Patch.Ammo(Selected) = Engine.Ammo(Selected)
    Patch.AmmoNames(Selected) = Engine.AmmoNames(Selected)

    ' Update information
    lstAmmo.List(Selected) = Patch.AmmoNames(Selected)
    Me.updateForm

    patchHasChanged

End Sub
