VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmEditSounds 
   Caption         =   "Sound editor"
   ClientHeight    =   6315
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   6060
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmEditSounds.frx":0000
   MDIChild        =   -1  'True
   ScaleHeight     =   421
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   404
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdRestore 
      Caption         =   "&Restore"
      Height          =   375
      Left            =   3480
      TabIndex        =   1
      ToolTipText     =   "Restore the selected sound(s)"
      Top             =   5760
      Width           =   2355
   End
   Begin MSComctlLib.ListView lvwSounds 
      Height          =   5595
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6030
      _ExtentX        =   10636
      _ExtentY        =   9869
      View            =   3
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   8
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "#"
         Object.Width           =   794
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Name"
         Object.Width           =   1587
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Offset"
         Object.Width           =   1799
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Sng"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(5) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   4
         Text            =   "Pri"
         Object.Width           =   952
      EndProperty
      BeginProperty ColumnHeader(6) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   5
         Text            =   "Refer"
         Object.Width           =   1587
      EndProperty
      BeginProperty ColumnHeader(7) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   6
         Text            =   "Pitch"
         Object.Width           =   1376
      EndProperty
      BeginProperty ColumnHeader(8) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   7
         Text            =   "Vol"
         Object.Width           =   952
      EndProperty
   End
End
Attribute VB_Name = "frmEditSounds"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmEditSounds.frm
'   Purpose: The sound editor
'
Option Explicit
Option Compare Binary
Option Base 0


' Restore the entry(s) to the Engine. struct
Private Sub cmdRestore_Click()

    Dim A As Long
    Dim Dummy As Long
    Dim nSelected As Long
    Dim QuestionString As String


    ' Count all of the selected items
    For A = 1 To lvwSounds.ListItems.Count
        If lvwSounds.ListItems(A).Selected = True Then nSelected = nSelected + 1
    Next A

    ' See what kind of question we need to ask
    If nSelected = 1 Then
        QuestionString = "Are you sure you want to restore this sound?"
    Else
        QuestionString = "Are you sure you want to restore these sounds?"
    End If

    ' Ask it
    Dummy = MsgBox(QuestionString, vbYesNo Or vbQuestion)
    If Dummy = vbNo Then Exit Sub

    ' Restore the data
    For A = 1 To lvwSounds.ListItems.Count

        If lvwSounds.ListItems(A).Selected = True Then
            ' Update table entry
            Patch.Sounds(A - 1) = Engine.Sounds(A - 1)
            Patch.SoundNames(A - 1) = Engine.SoundNames(A - 1)

            ' Update information
            modUtil.UpdateSoundEntry A - 1, lvwSounds
        End If

    Next A

    patchHasChanged

End Sub


' Form events
Private Sub Form_Load()

    Me.Width = 6210
    Me.Height = 6375

    appLog.Add "  Loaded " & Me.Name

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Hide the form instead
    Me.Hide
    frmMain.tlbEditors.Buttons(3).Value = tbrUnpressed
    Cancel = 1

End Sub

Private Sub Form_Resize()

    On Error Resume Next
    
    cmdRestore.Top = Me.ScaleHeight - cmdRestore.Height - 12
    cmdRestore.Left = Me.ScaleWidth - cmdRestore.Width - 18
    
    lvwSounds.Width = Me.ScaleWidth
    lvwSounds.Height = Me.ScaleHeight - cmdRestore.Height - 24

End Sub


' Fill the form with relevant table info
Public Sub fillStaticData()

    Dim A As Long, B As Long


    ' Fill the listview
    lvwSounds.ListItems.Clear
    For A = 0 To UBound(Patch.Sounds())

         ' Add the items
        lvwSounds.ListItems.Add
        For B = 0 To 7
            lvwSounds.ListItems(A + 1).ListSubItems.Add
        Next B

        ' Update the item
        modUtil.UpdateSoundEntry A, lvwSounds

    Next A

End Sub


' The user wants to edit a sound
Private Sub lvwSounds_DblClick()

    startEditSound lvwSounds.SelectedItem.Index - 1

End Sub


' Edit sound on enter press
Private Sub lvwSounds_KeyPress(KeyAscii As Integer)

    If KeyAscii = 13 Then startEditSound lvwSounds.SelectedItem.Index - 1

End Sub


' Do a sound preview when a right mouse button is used on an item
Private Sub lvwSounds_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim playSound As Long


    ' Only right mouse button
    If Button <> 2 Then Exit Sub

    ' Find out what item was hit (if any)
    If lvwSounds.HitTest(X, Y) Is Nothing Then
        Exit Sub
    Else
        playSound = lvwSounds.HitTest(X, Y).Index - 1
        previewSound playSound
    End If

End Sub


' Display a sound's property dialog
Public Sub startEditSound(ByRef SoundNum As Long)

    ' Don't allow changes to the dummy entry
    If SoundNum = 0 Then Exit Sub

    ' Exchange and update the data
    exchangeSound = Patch.Sounds(SoundNum)

    ' Set the form's caption
    frmPropSound.Caption = "Sound " & SoundNum & " (" & Trim$(Replace$(Patch.SoundNames(SoundNum), Chr$(0), Chr$(32))) & ")"

    frmPropSound.SetupData
    frmPropSound.Show 1

    ' See what we got back
    If exchangeSound.Priority <> -1 Then
        Patch.Sounds(SoundNum) = exchangeSound
        modUtil.UpdateSoundEntry SoundNum, lvwSounds

        patchHasChanged
    End If

End Sub
