VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmEditStrings 
   Caption         =   "String editor"
   ClientHeight    =   7035
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   8355
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmEditStrings.frx":0000
   MDIChild        =   -1  'True
   ScaleHeight     =   469
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   557
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdRestore 
      Caption         =   "&Restore"
      Height          =   375
      Left            =   5760
      TabIndex        =   1
      ToolTipText     =   "Restore the selected string(s)"
      Top             =   6480
      Width           =   2415
   End
   Begin MSComctlLib.ListView lvwStrings 
      Height          =   6315
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   8355
      _ExtentX        =   14737
      _ExtentY        =   11139
      View            =   3
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Bitstream Vera Sans Mono"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   3
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "#"
         Object.Width           =   1005
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Length"
         Object.Width           =   1587
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "String"
         Object.Width           =   55192
      EndProperty
   End
End
Attribute VB_Name = "frmEditStrings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmEditStrings.frm
'   Purpose: The string editor.
'
Option Explicit
Option Compare Binary
Option Base 0


' Form events
Private Sub Form_Load()

    Me.Width = 14955
    Me.Height = 9975

    appLog.Add "  Loaded " & Me.Name

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Hide the form instead of closing
    Me.Hide
    frmMain.tlbEditors.Buttons(5).Value = tbrUnpressed
    Cancel = 1

End Sub

Private Sub Form_Resize()

    On Error Resume Next
    
    cmdRestore.Top = Me.ScaleHeight - cmdRestore.Height - 12
    cmdRestore.Left = Me.ScaleWidth - cmdRestore.Width - 18
    
    lvwStrings.Width = Me.ScaleWidth
    lvwStrings.Height = Me.ScaleHeight - cmdRestore.Height - 24
    
End Sub


' Fill the form with the relevant data
Public Sub updateStringList()

    Dim A As Long
    Dim oldSelect As Long
    
    
    ' Change column captions to match mode
    If Engine.Extended = True Then
        lvwStrings.ColumnHeaders(2).Text = "String"
        lvwStrings.ColumnHeaders(2).Width = 156
    Else
        lvwStrings.ColumnHeaders(2).Text = "Length"
        lvwStrings.ColumnHeaders(2).Width = 60
    End If
    
    ' Remember selection
    If Not lvwStrings.SelectedItem Is Nothing Then
        oldSelect = lvwStrings.SelectedItem.Index
    Else
        oldSelect = -1
    End If
    
    ' Fill the list
    lvwStrings.ListItems.Clear
    For A = 0 To UBound(Patch.Strings())
    
        lvwStrings.ListItems.Add
        lvwStrings.ListItems(A + 1).ListSubItems.Add
        lvwStrings.ListItems(A + 1).ListSubItems.Add
        
        modUtil.UpdateStringEntry A, lvwStrings
    
    Next A
    
    ' Only select old selection if any
    lvwStrings.MultiSelect = False
    If oldSelect <> -1 Then
        lvwStrings.ListItems(oldSelect).Selected = True
        lvwStrings.ListItems(oldSelect).EnsureVisible
    End If
    lvwStrings.MultiSelect = True

End Sub


' Edit a string
Private Sub lvwStrings_DblClick()

    startEditString lvwStrings.SelectedItem.Index - 1

End Sub


' Edit a single string
Private Sub startEditString(ByVal stringIndex As Long)

    ' Transfer data
    With frmPropString
        .EngineString = Engine.Strings(stringIndex).Text
        .txtOldString = Returned(Escaped(Patch.Strings(stringIndex).Text))
        .txtNewString = Returned(Escaped(Patch.Strings(stringIndex).Text))
        
        ' Set form caption
        If Engine.Extended = True Then
            .Caption = "String " & stringIndex & ": " & Engine.ExtendedStrings.Keys(stringIndex)
        Else
            .Caption = "String " & stringIndex
        End If
    End With
            
    frmPropString.Show 1
    
    ' Retrieve data if things went okay
    If stringSuccessfull = True Then
        Patch.Strings(stringIndex).Text = UnEscaped(UnReturned(frmPropString.txtNewString.Text))
        Patch.Strings(stringIndex).Length = Len(Patch.Strings(stringIndex).Text)
        modUtil.UpdateStringEntry stringIndex, lvwStrings
        
        patchHasChanged
    End If

End Sub


' Restory any selected items
Private Sub cmdRestore_Click()

    Dim A As Long
    Dim Dummy As Long
    Dim nSelected As Long
    Dim QuestionString As String


    ' Count all of the selected items
    For A = 1 To lvwStrings.ListItems.Count
        If lvwStrings.ListItems(A).Selected = True Then nSelected = nSelected + 1
    Next A

    ' See what kind of question we need to ask
    If nSelected = 1 Then
        QuestionString = "Are you sure you want to restore this string?"
    Else
        QuestionString = "Are you sure you want to restore these strings?"
    End If

    ' Ask it
    Dummy = MsgBox(QuestionString, vbYesNo Or vbQuestion)
    If Dummy = vbNo Then Exit Sub

    ' Restore the data
    For A = 1 To lvwStrings.ListItems.Count

        If lvwStrings.ListItems(A).Selected = True Then
            ' Update table entry
            Patch.Strings(A - 1) = Engine.Strings(A - 1)
            
            ' Update information
            modUtil.UpdateStringEntry A - 1, frmEditStrings.lvwStrings
        End If

    Next A

    patchHasChanged
    
End Sub


' lvwStrings events
Private Sub lvwStrings_KeyPress(KeyAscii As Integer)

    If KeyAscii = 13 Then startEditString lvwStrings.SelectedItem.Index - 1

End Sub
