VERSION 5.00
Begin VB.Form frmNewFile 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Select file settings"
   ClientHeight    =   2535
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6795
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmNewFile.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   169
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   453
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox cmbEngineConfig 
      Height          =   315
      ItemData        =   "frmNewFile.frx":000C
      Left            =   180
      List            =   "frmNewFile.frx":000E
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   540
      Width           =   2835
   End
   Begin VB.ComboBox cmbIWADs 
      Height          =   315
      Left            =   3780
      Style           =   2  'Dropdown List
      TabIndex        =   1
      Top             =   540
      Width           =   2835
   End
   Begin VB.CommandButton cmdBrowseDataWAD 
      Caption         =   "..."
      Height          =   315
      Left            =   6060
      TabIndex        =   3
      ToolTipText     =   "Browse for a workspace image"
      Top             =   1380
      Width           =   555
   End
   Begin VB.TextBox txtDataWad 
      Height          =   315
      Left            =   180
      TabIndex        =   2
      Top             =   1380
      Width           =   5775
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   180
      TabIndex        =   4
      ToolTipText     =   "Restore the new string"
      Top             =   1980
      Width           =   2355
   End
   Begin VB.CommandButton cmdAccept 
      Caption         =   "&Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   4260
      TabIndex        =   5
      ToolTipText     =   "Restore the new string"
      Top             =   1980
      Width           =   2355
   End
   Begin VB.Label lblEngineConfig 
      Caption         =   "Engine configuration"
      Height          =   195
      Left            =   180
      TabIndex        =   8
      Top             =   240
      Width           =   1935
   End
   Begin VB.Label lblIWAD 
      Caption         =   "IWAD"
      Height          =   195
      Left            =   3780
      TabIndex        =   7
      Top             =   240
      Width           =   1335
   End
   Begin VB.Label lblDataWAD 
      Caption         =   "Data WAD"
      Height          =   195
      Left            =   180
      TabIndex        =   6
      Top             =   1080
      Width           =   1335
   End
End
Attribute VB_Name = "frmNewFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   frmNewFile.frm
'   Purpose: New file dialog
'
Option Explicit
Option Compare Binary
Option Base 0


' Who pressed Cancel?
Public BadNewFileResponse As Boolean

' Collection of IWAD filenames
Private IWADFiles As Collection

' What engine type is the current patch?
Private PatchEngineType As Long


' Accept config and load it and it's table
Private Sub cmdAccept_Click()
    
    ' Check if the engine versions match
    If PatchEngineType <> -1 And (ConfigFilesData(cmbEngineConfig.listIndex + 1) <> PatchEngineType) Then
        MsgBox "The patch file is not compatible with the selected engine configuration.", vbExclamation Or vbOKOnly
        Exit Sub
    End If

    Me.Hide

    ' Load configuration file
    appLog.Add "Loading engine configuration..."
    modConfig.LoadEngineConfig ConfigFiles.Keys(cmbEngineConfig.listIndex)

    ' Display Doom version info inot the app log
    appLog.Add "  Using '" & Engine.Name & "' as the current engine"
    appLog.Add "  Using engine version " & Engine.Version

    ' Load the engine tables
    appLog.Add "Loading table..."
    If modTables.loadEngineTables = False Then
        MsgBox "Could not load engine table.", vbExclamation Or vbOKOnly
        BadNewFileResponse = True
        Exit Sub
    End If
    
    ' Unload any old WAD files
    Set mainWad = Nothing
    Set dataWad = Nothing
    
    ' Clear WADList
    modWADList.ClearList
    
    ' Load IWAD
    appLog.Add "Loading IWAD..."
    Set mainWad = New clsWad
    mainWad.OpenWad IWADFiles.Item(cmbIWADs.listIndex + 1)
    
    ' Load possible data WAD
    If txtDataWad.Text <> vbNullString Then
    
        ' Does the WAD file exist?
        If Not FS.FileExists(txtDataWad.Text) Then
            appLog.Add "WARNING: Unable to load data WAD, file does not exist"
        Else
            ' Status
            appLog.Add "Loading data WAD..."
        
            ' Create and load
            Set dataWad = New clsWad
            dataWad.OpenWad txtDataWad.Text
        End If
        
    End If
    
    ' Register the WAD files
    appLog.Add "Registering WAD files..."
    If modWADList.RegisterWAD(mainWad) = False Then
        MsgBox "Unable to register IWAD.", vbExclamation Or vbOKOnly
        Exit Sub
    End If
    If Not (dataWad Is Nothing) And modWADList.RegisterWAD(dataWad) = False Then
        MsgBox "Unable to register data WAD.", vbExclamation Or vbOKOnly
        Exit Sub
    End If
    
    ' Load PLAYPAL lump
    Set lumpDict = modWADList.WADNumForName("PLAYPAL")
    If lumpDict Is Nothing Then
        MsgBox "Could not load PLAYPAL lump.", vbExclamation Or vbOKOnly
        Exit Sub
    End If
    paletteData = lumpDict("class").ReadLumpString(lumpDict("num"))
    appLog.Add "  Loaded PLAYPAL lump"
        
    ' Remember last configs
    Config.Root(True).Item("lastConfig") = cmbEngineConfig.listIndex
    Config.Root(True).Item("lastIWAD") = cmbIWADs.listIndex
        
    ' End me
    BadNewFileResponse = False
    
End Sub


' Browse for a data wad
Private Sub cmdBrowseDataWAD_Click()

    Dim fileList As Dictionary
    
    
    Set fileList = Dialog.openFile(Me.hWnd, "Select a WAD file", "WAD files (*.wad)|*.wad|All files (*.*)|*.*", vbNullString, vbNullString, cdlOFNHideReadOnly Or cdlOFNLongNames Or cdlOFNNoReadOnlyReturn)
    If fileList.Count > 0 Then txtDataWad.Text = fileList.Items(0)

End Sub


' Decline stuff and hide
Private Sub cmdCancel_Click()

    BadNewFileResponse = True
    Me.Hide

End Sub


' Form load event
Private Sub Form_Load()
    
    appLog.Add "  Loaded " & Me.Name

End Sub


' Select configuration file based on patch file information
Public Sub SelectConfig(ByRef PatchInfo As Dictionary)

    Dim A As Long
    Dim cItem As String
    Dim fileName As String
    Dim FileString As String
    
      
    ReFillConfigs
    
    ' Select the right configuration
    If PatchInfo.Exists("engineconfig") = True Then
        For A = 0 To ConfigFiles.Count - 1
            If ConfigFiles.Keys(A) = PatchInfo("engineconfig") Then
                cmbEngineConfig.listIndex = A
                cmbEngineConfig.List(A) = cmbEngineConfig.List(A) & " (recommended)"
                Exit For
            End If
        Next A
    End If
    
    ' Select the right IWAD
    If PatchInfo.Exists("iwad") = True Then
        With Config.Root(False).Item("IWADs")
            
            For A = 0 To .Count - 1
                
                ' Get item
                cItem = .Item("wad" & Trim$(Str$(A)))
                
                ' Parse filename
                fileName = Mid$(cItem, 1, InStr(1, cItem, ";") - 1)
                
                ' Select if found
                If LCase$(fileName) = LCase$(PatchInfo("iwad")) Then
                    cmbIWADs.listIndex = A
                    cmbIWADs.List(A) = cmbIWADs.List(A) & " (recommended)"
                    Exit For
                End If
                
            Next A
            
        End With
    End If
    
    
    ' Remember the configuration's engine type
    PatchEngineType = CLng(PatchInfo("engineversion"))
    
    ' Set data WAD
    If PatchInfo.Exists("datawad") Then
        txtDataWad.Text = PatchInfo("datawad")
    Else
        txtDataWad.Text = vbNullString
    End If
    
    ' Set form caption
    FileString = PatchInfo("filename")
    Me.Caption = "File settings of " & Mid$(FileString, InStrRev(FileString, "\") + 1)

End Sub


' Set the form's info to be creating a new file
Public Sub SetNewFile()

    ReFillConfigs
    
    ' A dummy engine type
    PatchEngineType = -1
    
    ' Erase data wad
    txtDataWad.Text = vbNullString
    
    ' Form caption
    Me.Caption = "New file"

End Sub


Private Sub ReFillConfigs()
    
    Dim A As Long
    Dim cItem As String
    Dim Description As String
    Dim fileName As String
    
      
    ' Add all the found configurations to the combobox
    cmbEngineConfig.Clear
    For A = 0 To ConfigFiles.Count - 1
        cmbEngineConfig.AddItem ConfigFiles.Items(A)
    Next A

    ' Select the default config
    If Config.Root(False)("lastConfig") < cmbEngineConfig.ListCount Then cmbEngineConfig.listIndex = Config.Root(False)("lastConfig")
    
    ' Clear data
    cmbIWADs.Clear
    Set IWADFiles = Nothing
    Set IWADFiles = New Collection

    ' Fill the IWAD list
    With Config.Root(False).Item("IWADs")
        
        For A = 0 To .Count - 1

            ' Get item
            cItem = .Item("wad" & Trim$(Str$(A)))
            
            ' Get description and item
            Description = Mid$(cItem, InStr(1, cItem, ";") + 1)
            fileName = Mid$(cItem, 1, InStr(1, cItem, ";") - 1)

            ' Add it to the list
            cmbIWADs.AddItem Description
            IWADFiles.Add fileName
            
        Next A
        
    End With

    ' Select default IWAD
    cmbIWADs.listIndex = Config.Root(False)("lastIWAD")
    
End Sub
