Attribute VB_Name = "modDebugTools"
' -------------------------------------------------------------------------------
'
'  WhackEd3 - A Windows Doom hacking utility
'  Copyright (C) 2003-2009  Dennis Meuwissen
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
' -------------------------------------------------------------------------------
'
'   modDebugTools.bas
'   Purpose: Debugging tools, not normally used in code.
'
Option Explicit
Option Compare Binary
Option Base 0


' Codepointer table writer (for CP->MNEMONIC conversion)
Public Sub WriteCodePointerList()

    Dim CPNums() As Long
    Dim A As Long
    Dim B As Long
    Dim OpenFile As Integer


    ReDim CPNums(0)

    For A = 0 To UBound(Engine.States())
        For B = 0 To UBound(CPNums())
            If CPNums(B) = Engine.States(A).CodePointer Then GoTo Meed
        Next B

        ReDim Preserve CPNums(UBound(CPNums()) + 1)
        CPNums(UBound(CPNums())) = Engine.States(A).CodePointer

Meed:
    Next A


    OpenFile = FreeFile
    Open APP_PATH & "cpdata.txt" For Output As #OpenFile
        For A = 0 To UBound(CPNums())
            Print #OpenFile, CPNums(A)
        Next A
    Close #OpenFile


    appLog.Add "Wrote " & APP_PATH & "cpdata.txt"

End Sub


' Codepointer comparison table writer
Public Sub WriteCodePointerComparisons()

    Dim A As Long
    Dim OpenFile As Integer


    OpenFile = FreeFile
    Open APP_PATH & "cps.txt" For Output As #OpenFile

        For A = 0 To UBound(Engine.CodePointers())
            Print #OpenFile, "State: " & Chr$(9) & Patch.States(A).CodePointer & Chr$(9) & Chr$(9) & "CP:" & Chr$(9) & Patch.CodePointers(A)
        Next A

    Close #OpenFile


    appLog.Add "Wrote " & APP_PATH & "cps.txt"

End Sub


' Time the duration of the filling of the States ListView control
Public Sub TimeStateListViewFiller()

    Dim startTime As Double
    Dim endTime As Double


    appLog.Add "Busy..."

    startTime = Timer
    frmEditStates.updateStateList
    endTime = Timer

    appLog.Add "Operation took " & endTime - startTime & " seconds."

End Sub
