// -------------------------------------------------------------------------------
//
//  WhackEd3 - A Windows DehackEd clone
//  Copyright (C) 2006-2009  Dennis Meuwissen
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
// -------------------------------------------------------------------------------
//
//   File purpose: Utility functions
//

#include "dll.h"


// Converts a cheat string to its decrypted equivalent. If the cheat is not
// as long as 'length', string will be padded with FFs. Does NOT append a
// NULL character.
void EXPORT CheatToString(unsigned char* cheat, unsigned char* string, int length)
{
	
	int i = 0;


	// Continue converting until we run into the end of the string, or
	// we've converted 'length' characters.
	while ((i < length) && (cheat[i] != 0))
	{
		string[i]  =  cheat[i] & 36;
		string[i] |= (cheat[i] & 128) >> 7;
		string[i] |= (cheat[i] & 64) >> 5;
		string[i] |= (cheat[i] & 16) >> 1;
		string[i] |= (cheat[i] & 8) << 1;
		string[i] |= (cheat[i] & 2) << 5;
		string[i] |= (cheat[i] & 1) << 7;

		i++;
	}

	// Pad the rest of the string with FFs.
	while (i < length)
		string[i++] = 0xFF;

}



// Set a flag
int EXPORT SetFlag(unsigned int changeval, unsigned int flagnum)
{

	return changeval |= (1 << flagnum);

}


// Remove a flag
int EXPORT RemoveFlag(unsigned int changeval, unsigned int flagnum)
{

	return changeval &= ~(1 << flagnum);

}


// Get a flag
int EXPORT GetFlag(unsigned int useval, unsigned int flagnum)
{

	if ((useval & (1 << flagnum)))
		return 1;
	else
		return 0;

}